
#ifdef LOADDEVS
#include <fcntl.h>
#undef devices

#define CFG_FILE1    "/.mtoolsrc"
#define CFG_FILE2    "/etc/mtools"

#define MAX_LINE    MAXPATHLEN+40
#define MAX_DEVICES 100

#ifdef __STDC__
# define AUX(x) #x
# define STR(x) AUX(x)
#else
# define STR(x) "x"
#endif

#define SET(f,t,h,s) \
  { devices[dev].fat_bits = (f); devices[dev].tracks = (t); \
  devices[dev].heads = (h); devices[dev].sectors = (s); }

struct device devices[MAX_DEVICES+1];

void load_devices(void)
{
	FILE *cfg;
	char buffer[MAX_LINE+1],name[MAXPATHLEN+1];
	char *here,*start;
	int items,dev;
	char *homedir;
	char conf_file[MAXPATHLEN+sizeof(CFG_FILE1)];
	int linenumber;

	homedir = get_homedir();

	if ( homedir ){
		strncpy(conf_file, homedir, MAXPATHLEN );
		conf_file[MAXPATHLEN]='\0';
		strcat( conf_file, CFG_FILE1 );
		cfg = fopen(conf_file,"r");
	} else 
		cfg = NULL;

	if ( !cfg )
		cfg = fopen(CFG_FILE2, "r" );

	if (cfg == NULL) {
		perror(CFG_FILE2);
		exit(1);
	}

	dev = 0;
	linenumber = 0;
	while (fgets(buffer,MAX_LINE,cfg)) {
		linenumber++;
		if ((here = strchr(buffer,'#'))) *here = 0;
		if ((here = strchr(buffer,'\n'))) *here = 0;
		for (start = buffer; *start == ' ' || *start == '\t'; start++);
		if (!*start) continue;
		if (dev >= MAX_DEVICES) {
			fprintf(stderr,"Too many devices\n");
			exit(1);
		}
		items = sscanf(start,"%c %s %d %d %d %d %ld",
			       &devices[dev].drive,name,&devices[dev].fat_bits,
			       &devices[dev].tracks,&devices[dev].heads,
			       &devices[dev].sectors, &devices[dev].offset);
		switch(items){
		case 2:
			devices[dev].fat_bits = 0;
			/* fall thru */
		case 3:
			devices[dev].sectors = 0;
			devices[dev].heads = 0;
			devices[dev].tracks = 0;
			/* fall thru */
		case 6:
			devices[dev].offset = 0;
			/* fall thru */
		default:
			break;
		case 0:
		case 1:
		case 4:
		case 5:
			fprintf(stderr,"Error in config file line: %d",
				linenumber);
			fprintf(stderr,"Config file syntax: drive device "
				"[ fat [ tracks heads sectors ] ]\n");
			exit(1);		
		}
		if(!devices[dev].tracks){
			devices[dev].sectors = 0;
			devices[dev].heads = 0;
		}
		  
		if (islower(devices[dev].drive))
			devices[dev].drive = toupper(devices[dev].drive);
		devices[dev].mode = 0;
		devices[dev].gioctl = INIT_DEFAULT;
		if ((devices[dev].name = 
		     (char *)malloc(strlen(name)+1)) == NULL) {
			fprintf(stderr,"Out of memory\n");
			exit(1);
		}
		strcpy(devices[dev++].name,name);
	}
	memset(&devices[dev],0,sizeof(struct device));
	fclose(cfg);
}

#endif /* LOADDEVS */
