/*
 * Device tables.  See the Configure file for a complete description.
 */

#include <stdio.h>
#include "msdos.h"

#ifdef linux
struct device devices[] = {
	{'A', "/dev/fd0H1440", 0L, 12, 0, (int (*) ()) 0, 80, 2, 18},
	{'B', "/dev/fd0D720", 0L, 12, 0, (int (*) ()) 0, 80, 2, 9},
	{'M', "DISPLAY:/dev/fd0H1440", 0L, 12, 0, (int (*) ()) 0, 80, 2, 18},
	{'N', "DISPLAY:/dev/fd0D720", 0L, 12, 0, (int (*) ()) 0, 80, 2, 9},
};
#endif

#ifdef DELL
struct device devices[] = {
	{'A', "/dev/rdsk/f0d9dt", 0L, 12, 0, (int (*) ()) 0, 40, 2, 9},
	{'A', "/dev/rdsk/f0q15dt", 0L, 12, 0, (int (*) ()) 0, 80, 2, 15},
	{'A', "/dev/rdsk/f0d8dt", 0L, 12, 0, (int (*) ()) 0, 40, 2, 8},
	{'B', "/dev/rdsk/f13ht", 0L, 12, 0, (int (*) ()) 0, 80, 2, 18},
	{'B', "/dev/rdsk/f13dt", 0L, 12, 0, (int (*) ()) 0, 80, 2, 9},
	{'C', "/dev/rdsk/dos", 0L, 16, 0, (int (*) ()) 0, 0, 0, 0},
	{'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};
#endif /* DELL */

#ifdef ISC
struct device devices[] = {
	{'A', "/dev/rdsk/f0d9dt", 0L, 12, 0, (int (*) ()) 0, 40, 2, 9},
	{'A', "/dev/rdsk/f0q15dt", 0L, 12, 0, (int (*) ()) 0, 80, 2, 15},
	{'A', "/dev/rdsk/f0d8dt", 0L, 12, 0, (int (*) ()) 0, 40, 2, 8},
	{'B', "/dev/rdsk/f13ht", 0L, 12, 0, (int (*) ()) 0, 80, 2, 18},
	{'B', "/dev/rdsk/f13dt", 0L, 12, 0, (int (*) ()) 0, 80, 2, 9},
	{'C', "/dev/rdsk/0p1", 0L, 16, 0, (int (*) ()) 0, 0, 0, 0},
	{'D', "/usr/vpix/defaults/C:", 8704L, 12, 0, (int (*) ()) 0, 0, 0, 0},
	{'E', "$HOME/vpix/C:", 8704L, 12, 0, (int (*) ()) 0, 0, 0, 0},
	{'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};
#endif /* ISC */

#ifdef SPARC
struct device devices[] = {
	{'A', "/dev/rfd0c", 0L, 12, 0, (int (*) ()) 0, 80, 2, 18},
	{'A', "/dev/rfd0c", 0L, 12, 0, (int (*) ()) 0, 80, 2, 9},
	{'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};
#endif /* SPARC */
#ifdef RT_ACIS
struct device devices[] = {
      {'A', "/dev/rfd0", 0L, 12, 0, (int (*) ()) 0, 80, 2, 15},
      {'A', "/dev/rfd0", 0L, 12, 0, (int (*) ()) 0, 40, 2, 9},
      {'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};
#endif /* RT_ACIS */


#ifdef UNIXPC
#include <sys/gdioctl.h>
#include <fcntl.h>

int init_unixpc();

struct device devices[] = {
	{'A', "/dev/rfp020", 0L, 12, O_NDELAY, init_unixpc, 40, 2, 9},
	{'C', "/usr/bin/DOS/dvd000", 0L, 12, 0, (int (*) ()) 0, 0, 0, 0},
	{'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};

int
init_unixpc(fd, ntracks, nheads, nsect)
int fd, ntracks, nheads, nsect;
{
	struct gdctl gdbuf;

	if (ioctl(fd, GDGETA, &gdbuf) == -1) {
		ioctl(fd, GDDISMNT, &gdbuf);
		return(1);
	}

	gdbuf.params.cyls = ntracks;
	gdbuf.params.heads = nheads;
	gdbuf.params.psectrk = nsect;

	gdbuf.params.pseccyl = gdbuf.params.psectrk * gdbuf.params.heads;
	gdbuf.params.flags = 1;		/* disk type flag */
	gdbuf.params.step = 0;		/* step rate for controller */
	gdbuf.params.sectorsz = 512;	/* sector size */

	if (ioctl(fd, GDSETA, &gdbuf) < 0) {
		ioctl(fd, GDDISMNT, &gdbuf);
		return(1);
	}
	return(0);
}
#endif /* UNIXPC */

#ifdef RT_ACIS
struct device devices[] = {
	{'A', "/dev/rfd0", 0L, 12, 0, (int (*) ()) 0, 80, 2, 15},
	{'A', "/dev/rfd0", 0L, 12, 0, (int (*) ()) 0, 40, 2, 9},
	{'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};
#endif /* RT_ACIS */

#ifdef SUN386
struct device devices[] = {
	{'A', "/dev/rfdl0c", 0L, 12, 0, (int (*) ()) 0, 80, 2, 9},
	{'A', "/dev/rfd0c", 0L, 12, 0, (int (*) ()) 0, 80, 2, 18},
	{'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};
#endif /* SUN386 */

  
#ifdef SPARC_ODD
#include <sys/types.h>
#include <sun/dkio.h>
#include <fcntl.h>

int init_sparc();

struct device devices[] = {
	{'A', "/dev/rfd0c", 0L, 12, 0, init_sparc, 80, 2, 0},
	{'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};

/*
 * Stuffing back the floppy parameters into the driver allows for gems
 * like 10 sector or single sided floppies from Atari ST systems.
 * 
 * Martin Schulz, Universite de Moncton, N.B., Canada, March 11, 1991.
 */

int
init_sparc(fd, ntracks, nheads, nsect)
int fd, ntracks, nheads, nsect;
{
	struct fdk_char dkbuf;
	struct dk_map   dkmap;

	if (ioctl(fd, FDKIOGCHAR, &dkbuf) != 0) {
		ioctl(fd, FDKEJECT, NULL);
		return(1);
	}

	if (ioctl(fd, DKIOCGPART, &dkmap) != 0) {
		ioctl(fd, FDKEJECT, NULL);
		return(1);
	}

	if (ntracks)
		dkbuf.ncyl = ntracks;
	if (nheads)
		dkbuf.nhead = nheads;
	if (nsect)
		dkbuf.secptrack = nsect;

	if (ntracks && nheads && nsect )
		dkmap.dkl_nblk = ntracks * nheads * nsect;

	if (ioctl(fd, FDKIOSCHAR, &dkbuf) != 0) {
		ioctl(fd, FDKEJECT, NULL);
		return(1);
	}

	if (ioctl(fd, DKIOCSPART, &dkmap) != 0) {
		ioctl(fd, FDKEJECT, NULL);
		return(1);
	}
	return(0);
}
#endif /* SPARC_ODD */
  
#ifdef XENIX
struct device devices[] = {
	{'A', "/dev/fd096ds15", 0L, 12, 0, (int (*) ()) 0, 80, 2, 15},
	{'A', "/dev/fd048ds9", 0L, 12, 0, (int (*) ()) 0, 40, 2, 9},
	{'B', "/dev/fd1135ds18", 0L, 12, 0, (int (*) ()) 0, 80, 2, 18},
	{'B', "/dev/fd1135ds9", 0L, 12, 0, (int (*) ()) 0, 80, 2, 9},
	{'C', "/dev/hd0d", 0L, 16, 0, (int (*) ()) 0, 0, 0, 0},
	{'\0', (char *) NULL, 0L, 0, 0, (int (*) ()) 0, 0, 0, 0}
};
#endif /* XENIX */


/* stolen from mtools-2.5/devices.c */
#ifdef LOADDEVS
#include <fcntl.h>
#include <sys/param.h>
#undef devices

#define CFG_FILE1    "/.mtoolsrc"
#define CFG_FILE2    "/etc/mtools"

#define MAX_LINE    MAXPATHLEN+40
#define MAX_DEVICES 100
#define INIT_DEFAULT NULL

#ifdef __STDC__
# define AUX(x) #x
# define STR(x) AUX(x)
#else
# define STR(x) "x"
#endif

#define SET(f,t,h,s) \
  { devices[dev].fat_bits = (f); devices[dev].tracks = (t); \
  devices[dev].heads = (h); devices[dev].sectors = (s); }

struct device devices[MAX_DEVICES+1];

/* stolen from mtools-2.5/misc.c */

#ifndef FLOPPY_SECURE
#ifdef hpux
#define _INCLUDE_POSIX_SOURCE
#endif
# include <pwd.h>

char *get_homedir(void)
{
        struct passwd *pw;
        int uid;
        char *homedir;
        char *username;
        
        homedir = getenv ("HOME");    
        /* 
         * first we call getlogin. 
         * There might be several accounts sharing one uid 
         */
        if ( homedir )
                return homedir;
        
        pw = 0;
        
        username = getenv("LOGNAME");
        if ( !username )
                username = getlogin();
        if ( username )
                pw = getpwnam( username);
  
        if ( pw == 0 ){
                /* if we can't getlogin, look up the pwent by uid */
                uid = geteuid();
                pw = getpwuid(uid);
        }
        
        /* we might still get no entry */
        if ( pw )
                return pw->pw_dir;
        return 0;
}
#endif /* FLOPPY_SECURE */


void load_devices(void)
{
	FILE *cfg;
	char buffer[MAX_LINE+1],name[MAXPATHLEN+1];
	char *here,*start;
	int items,dev;
	char *homedir;
	char conf_file[MAXPATHLEN+sizeof(CFG_FILE1)];
	int linenumber;

#ifndef FLOPPY_SECURE
	homedir = get_homedir();

	if ( homedir ){
		strncpy(conf_file, homedir, MAXPATHLEN );
		conf_file[MAXPATHLEN]='\0';
		strcat( conf_file, CFG_FILE1 );
		cfg = fopen(conf_file,"r");
	} else 
		cfg = NULL;

	if ( !cfg )
#endif /* FLOPPY_SECURE */
		cfg = fopen(CFG_FILE2, "r" );

	if (cfg == NULL) {
		perror(CFG_FILE2);
		exit(1);
	}

	dev = 0;
	linenumber = 0;
	while (fgets(buffer,MAX_LINE,cfg)) {
		linenumber++;
		if ((here = strchr(buffer,'#'))) *here = 0;
		if ((here = strchr(buffer,'\n'))) *here = 0;
		for (start = buffer; *start == ' ' || *start == '\t'; start++);
		if (!*start) continue;
		if (dev >= MAX_DEVICES) {
			fprintf(stderr,"Too many devices\n");
			exit(1);
		}
		items = sscanf(start,"%c %s %d %d %d %d %ld",
			       &devices[dev].drive,name,&devices[dev].fat_bits,
			       &devices[dev].tracks,&devices[dev].heads,
			       &devices[dev].sectors, &devices[dev].offset);
		switch(items){
		case 2:
			devices[dev].fat_bits = 0;
			/* fall thru */
		case 3:
			devices[dev].sectors = 0;
			devices[dev].heads = 0;
			devices[dev].tracks = 0;
			/* fall thru */
		case 6:
			devices[dev].offset = 0;
			/* fall thru */
		default:
			break;
		case 0:
		case 1:
		case 4:
		case 5:
			fprintf(stderr,"Error in config file line: %d",
				linenumber);
			fprintf(stderr,"Config file syntax: drive device "
				"[ fat [ tracks heads sectors ] ]\n");
			exit(1);		
		}
		if(!devices[dev].tracks){
			devices[dev].sectors = 0;
			devices[dev].heads = 0;
		}
		  
		if (islower(devices[dev].drive))
			devices[dev].drive = toupper(devices[dev].drive);
		devices[dev].mode = 0;
		devices[dev].gioctl = INIT_DEFAULT;
		if ((devices[dev].name = 
		     (char *)malloc(strlen(name)+1)) == NULL) {
			fprintf(stderr,"Out of memory\n");
			exit(1);
		}
		strcpy(devices[dev++].name,name);
	}
	memset(&devices[dev],0,sizeof(struct device));
	fclose(cfg);
}

#endif /* LOADDEVS */
